<!DOCTYPE html>
<html lang="en" th:lang="#{lang}" xmlns:th="http://www.thymeleaf.org"
      xmlns:sec="http://www.thymeleaf.org/extras/spring-security">
<head>
    <!--CSS -->
    <link th:href="@{/css/lightpick.css}" rel="stylesheet" type="text/css">

    <!--<link  href="https://cdnjs.cloudflare.com/ajax/libs/fotorama/4.6.4/fotorama.css" rel="stylesheet">-->

    <!--/*/ <th:block th:include="fragments/layout :: head">
        </th:block> /*/-->


    <!--<script src="https://cdnjs.cloudflare.com/ajax/libs/fotorama/4.6.4/fotorama.js"></script>-->

    <!--SCRIPTS-->
    <script src="https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.22.2/moment.min.js"></script>
    <script th:src="@{/js/lightpick.js}" type="text/javascript"></script>
    <script src="https://www.google.com/recaptcha/api.js" async defer></script>
</head>
<body>

<div id="wrapper">

    <div th:replace="fragments/layout :: header('admin')"></div>

    <main id="main" class="container mt-2">

        <div class="d-lg-flex">
            <div class="p-2">
                <!--SIDE NAV-->
                <div th:replace="fragments/layout :: adminSideNav('borrows')"></div>
            </div>

            <div class="flex-grow-1 p-2">

                <div th:replace="fragments/layout :: alerts"></div>

                <div class="mb-3 pb-2 border-bottom clearfix" sec:authorize="hasRole('ADMIN')">
                    <h2 class="float-left">Nová rezervace / výpůjčka</h2>
                </div>

                <div>
                    <form id="product-form" class="needs-validation" method="post" enctype="multipart/form-data"
                          autocomplete="off"
                          th:action="@{/admin/borrow/add}" th:object="${borrow}" th:fragment="productEdit(product)"
                          novalidate>

                        <!--<input type="hidden" id="product.name" name="product.name" th:value="${product.name}">
                        <input type="hidden" th:value="${product.id}" id="product.id" name="product.id">-->

                        <div th:fragment="innerForm(borrow, product)">
                            <!--PRODUCT-->
                            <div class="mb-3">
                                <div class="pb-1">
                                    <label class="font-weight-bold mb-0 mt-1">Produkt:</label>
                                </div>

                                <!--AUTOCOMPLETE USER-->
                                <div class="autocomplete w-100">
                                    <input id="productInput" class="form-control" type="text"
                                           placeholder="Název, id nebo kategorie" tabindex="1" required
                                           th:value="${borrow.product != null ? borrow.product.name : ''}">
                                    <input id="productHdnId" type="hidden" th:field="*{product.id}">
                                    <span class="text-danger invalid-feedback">produkt je povinný</span>
                                </div>
                            </div>

                            <!--USER-->
                            <div class="mb-3">
                                <div class="d-flex pb-1">
                                    <label class="font-weight-bold mb-0 mt-1 mr-2">Zákazník:</label>
                                    <div class="ml-auto">
                                        <a class="btn btn-sm btn-outline-secondary" th:href="@{/admin/user/new}"
                                           target="_blank">
                                            <i class="fas fa-user-plus"></i>
                                            Nový zákazník
                                        </a>
                                    </div>
                                </div>

                                <!--AUTOCOMPLETE USER-->
                                <div class="autocomplete w-100">
                                    <input id="customerInput" class="form-control" type="text"
                                           placeholder="Jméno, firma, email nebo telefon" tabindex="2" required
                                           th:value="${borrow.user != null ? borrow.user.getFullName() : ''}">
                                    <input id="customerHdnId" type="hidden" th:field="*{user.id}">
                                    <span class="text-danger invalid-feedback">zákazník je povinný</span>
                                </div>
                            </div>

                            <div id="productPart"
                                 th:fragment="productPart(borrow, product, availableDate, unavailableDates)">
                                <!--DATEPICKER-->
                                <div class="form-group">
                                    <label for="fromDateInput" class="font-weight-bold">Datum:</label>

                                    <div th:if="${product != null}">
                                        <!--BORROW ERROR-->
                                        <div id="borrowError" class="alert alert-danger alert-dismissible"
                                             th:classappend="${borrowErrorMessage} == null ? 'd-none' : ''"
                                             role="alert">
                                    <span id="borrowErrorMessage"
                                          th:text="${borrowErrorMessage != null ? borrowErrorMessage : ''}"></span>
                                            <button type="button" class="close" onclick="closeAlert('#borrowError');">
                                                <span aria-hidden="true">&times;</span>
                                            </button>
                                        </div>

                                        <div class="w-100 text-center">
                                            <input type="hidden" id="fromDateInput" required name="fromDate">
                                            <input type="hidden" id="toDateInput" required name="toDate">
                                        </div>
                                    </div>
                                    <div th:if="${product == null}" class="alert alert-warning" role="alert">
                                        Nejprve vyberte produkt
                                    </div>
                                </div>

                                <div th:if="${product != null}">

                                    <!--ACCESSORY-->
                                    <div class="form-group">
                                        <label class="font-weight-bold">Příslušenství:</label>
                                        <div>
                                            <div th:if="${not #lists.isEmpty(product.getAvailableAccessories())}">
                                                <div class="ml-2"
                                                     th:each="accessory,iStat : ${product.getAvailableAccessories()}">
                                                    <label class="control control--checkbox">
                                                        <span th:text="${accessory.name}"></span>
                                                        <input type="checkbox" class="" th:value="${accessory.id}"
                                                               th:name="'accessories[' + ${iStat.index} + '].id'"
                                                               tabindex="3"
                                                               th:checked="${borrow.isAccessorySelected(accessory)}"/>
                                                        <!--name="accessories[1].id"-->
                                                        <div class="control__indicator"></div>
                                                    </label>
                                                    <input type="hidden"
                                                           th:field="${borrow.accessories[__${iStat.index}__].name}">
                                                </div>
                                            </div>
                                        </div>
                                    </div>

                                    <!-- PRICE -->
                                    <div>
                                        <label class="font-weight-bold">Cena:</label>
                                        <table class="table w-100">
                                            <tbody>
                                            <tr class="table-sm">
                                                <td th:text="${product.name}">MiniBagr</td>
                                                <td class="text-center">
                                                    <span th:text="${product.getRoundPrice()}"></span>
                                                    <span> Kč/den</span>
                                                </td>
                                            </tr>
                                            <tr class="table-sm">
                                                <td>
                                                    <span id="dateFrom"></span>
                                                    -
                                                    <span id="dateTo"></span>
                                                </td>
                                                <td class="text-center">
                                                    <span class="dayCount">1</span>
                                                    <span id="dayName">den</span>
                                                </td>
                                            </tr>
                                            <tr class="table-active">
                                                <td>Celkem</td>
                                                <td class="text-center">
                                                <span class="small">
                                                    <span th:text="${product.getRoundPrice()}">1500</span>
                                                    *
                                                    <span th:class="dayCount">1</span>
                                                    =
                                                </span>
                                                    <span id="totalPrice" class="font-weight-bold"
                                                          th:text="${product.getRoundPrice()}"></span>
                                                    Kč
                                                </td>
                                            </tr>
                                            </tbody>
                                        </table>
                                    </div>


                                    <script th:inline="javascript">
                                        /*<![CDATA[*/

                                        if (document.getElementById('fromDateInput')) {

                                            var isSecondClick = false;

                                            var dateFrom = $("#dateFrom");
                                            var dateTo = $("#dateTo");
                                            var dayName = $("#dayName");
                                            var dayCount = $(".dayCount");
                                            var totalPrice = $("#totalPrice");

                                            var strDates = /*[[${unavailableDates}]]*/ '';
                                            var unavailDates;

                                            if (strDates !== "") {
                                                unavailDates = JSON.parse(/*[[${unavailableDates}]]*/ '');
                                            } else {
                                                unavailDates = null;
                                            }

                                            /*datumy z uložené rezervace*/
                                            var borrowFromDate = /*[[${borrow.fromDate}]]*/'';
                                            var borrowToDate = /*[[${borrow.toDate}]]*/'';
                                            var availableDate = /*[[${availableDate}]]*/ '';

                                            if (!borrowFromDate || !borrowToDate) {
                                                borrowFromDate = availableDate;
                                                borrowToDate = availableDate;
                                            }

                                            dateFrom.html(moment(borrowFromDate).format('DD.MM.YYYY'));
                                            dateTo.html(moment(borrowToDate).format('DD.MM.YYYY'));

                                            var picker = new Lightpick({
                                                field: document.getElementById('fromDateInput'),
                                                secondField: document.getElementById('toDateInput'),
                                                singleDate: false,
                                                inline: true,
                                                format: "DD.MM.YYYY",
                                                lang: "cs",
                                                numberOfMonths: ($(window).width() > 750) ? 2 : 1,
                                                minDate: moment(),
                                                separator: ";",
                                                selectForward: true,
                                                disableDates: unavailDates,
                                                hoveringTooltip: false,
                                                startDate: borrowFromDate,
                                                endDate: borrowToDate,
                                                /*maxDays: 31,*/
                                                onSelect: function (start, end) {
                                                    if (isSecondClick && end != null && start <= end) {
                                                        var collisionDates = $('.lightpick__day.is-disabled.is-in-range')
                                                        if (collisionDates.length > 0) {
                                                            showCollisionDatesError(collisionDates);
                                                        } else {
                                                            var error = $('#borrowError');
                                                            error.removeClass('show');
                                                            error.addClass('d-none');
                                                        }

                                                        var days = $(".is-in-range").length; //moment.duration(end - start).days() + 1;
                                                        dayCount.html(days);
                                                        dayName.html(getDayName(days));
                                                        totalPrice.html(days * /*[[${product.price}]]*/ '');
                                                        dateFrom.html(start.format('DD.MM.YYYY'));
                                                        dateTo.html(end.format('DD.MM.YYYY'));
                                                        recolorNewBorrowSubmitBtns();
                                                    }

                                                    //if(end == null || start <= end) {
                                                    isSecondClick = !isSecondClick;
                                                    //}
                                                }
                                            });
                                        }

                                        /*]]>*/
                                    </script>

                                </div>
                            </div>
                        </div>

                        <input type="hidden" id="inputIsReservation" name="isReservation" value="true">
                        <div class="d-flex flex-wrap">
                            <!--reCAPTCHA-->
                            <!--<div class="g-recaptcha"
                                 data-sitekey="6Ld0Q7sUAAAAAEAUcwFYvKyHu6XzyM1_2lpX5ZJV"></div>-->

                            <button id="reservationBtn" type="submit" onclick="return submitBtnClicked(true)"
                                    class="btn btn-outline-secondary w-100 w-sm-auto px-4 m-1 ml-sm-auto" tabindex="4">
                                Rezervovat
                            </button>

                            <button id="borrowBtn" type="submit" onclick="return submitBtnClicked(false);"
                                    class="btn btn-outline-secondary w-100 w-sm-auto px-4 m-1" tabindex="5">
                                Vypůjčit
                            </button>
                        </div>

                    </form>
                </div>

            </div>

        </div>
    </main>
</div>

<script>
    $(document).ready(function () {
        recolorNewBorrowSubmitBtns();
    });

    function submitBtnClicked(isReservation) {
        $('#inputIsReservation').val(isReservation);

        return checkCollisions();
    }

    /*USER AUTOCOMPLETE*/
    userAutocomplete(document.getElementById("customerInput"), document.getElementById("customerHdnId"));

    /*PRODUCT AUTOCOMPLETE*/
    productAutocomplete(document.getElementById("productInput"), document.getElementById("productHdnId"));

</script>

<div th:replace="fragments/layout :: footer"></div>


</body>
</html>